// CS205 Fall 2006
// CellState.java

import java.awt.Color;

public class CellState {
	// OVERVIEW: A CellState is an immutable object that represents
	// the state of a cell, either alive or dead.

	private boolean alive;

	private CellState(boolean isalive)
	// EFFECTS: Initializes this to alive if isalive is true,
	// otherwise initializes this to the dead state.
	{
		this.alive = isalive;
	}

	static public/* nonnull */CellState createAlive()
	// EFFECTS: Returns an alive cell state.
	{
		return new CellState(true);
	}

	static public/* nonnull */CellState createDead()
	// EFFECTS: Returns a dead cell state.
	{
		return new CellState(false);
	}

	public Color getColor() 
	// EFFECTS: Returns the display color for this state
	{
		if (alive) return Color.green;
		else return Color.white;
		
	}
	
	public boolean equals(CellState s) {
		return s.alive == alive;
	}

	public boolean equals(Object o) {
		try {
			return equals((CellState) o);
		} catch (ClassCastException e) {
			return false;
		}
	}

	public boolean isAlive()
	// EFFECTS: Returns true iff this is alive.
	{
		return alive;
	}
}
